/*
 *  helpChild.java
 */

 import java.io.*;
 import java.util.*;
 import java.lang.*;   
 import java.lang.Object.*;
 import java.awt.*;
 import java.awt.event.*;
 import java.lang.Object.*;
 import java.awt.FlowLayout.*;
 import javax.comm.*; 
 import javax.swing.*;
 import javax.swing.border.*;
 import javax.swing.JScrollPane.*;

 /**
   *  helpChild 
   *   
   *  @version 2.0
   *  @author R.v.S - Team
   *
   *  helpChild ist die abgespeckte Version von openChild und
   *  wird benötigt um das ReadMe File im Programm anzuzeigen.
   *
   */
   
 public class helpChild
 extends JInternalFrame
 implements ActionListener
 {
   private Container cp;
   public JTextArea  txtAusgabe;
   public JTextField txtEingabe;
   public String filename;
   
   /**
     *  Der Konstruktor sorgt dafür das init aufgerufen wird und
     *  der Titel und die Größe gesetzt werden.
     */
   
   public helpChild(String title, String filename)  {
   	 super(title, true, true);
	 this.filename=filename;
     int x=500, y=500;
     setIconifiable(false);
     setMaximizable(false);
     setResizable(false);
     setSize(x+10, y+100); 
     setDefaultCloseOperation(JInternalFrame.DISPOSE_ON_CLOSE);     
     cp = getContentPane();     
     init(x,y);
   } 
   
   /**
     *  init initialisiert und erstellt alle Komponenten die 
     *  auf den Frame dargestellt werden sollen.
     *
     */
   
   private void init(int x, int y) {     
     cp.setLayout(null);
     cp.setBounds(0,0,x,y);
   
     JPanel Pane = new JPanel();
     Pane.setBounds(20,20,400,500);
     BoxLayout pBox = new BoxLayout(Pane, BoxLayout.Y_AXIS);
     Pane.setLayout(pBox);
     
     JTextArea textArea = new JTextArea();
      textArea.setFont(new Font("Courier New", Font.BOLD, 12));
      textArea.setLineWrap(true);
      textArea.setWrapStyleWord(true);
      textArea.setEnabled(false);
     int c;
     StringBuffer s = new StringBuffer();
   	 String line="";
     FileReader f;
     try {
       f = new FileReader(filename);
       while ((c = f.read()) != -1) {
       	s.append((char)c);         
       }
       f.close();
     } catch (IOException e) {
       String message ="Fehler beim öffnen der Datei : "+filename+"\n"+e.toString();
       System.out.println(message);
       JOptionPane.showMessageDialog(
       		this,
       		message,
       		"File Open Error", 
       		JOptionPane.ERROR_MESSAGE);  
     }
     textArea.append(s.toString());
     JScrollPane areaScrollPane = new JScrollPane(textArea);
      areaScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
      areaScrollPane.setPreferredSize(new Dimension(250, 250));
      areaScrollPane.setBorder(
        BorderFactory.createCompoundBorder(
          BorderFactory.createCompoundBorder(
            BorderFactory.createTitledBorder("Info Text"),
            BorderFactory.createEmptyBorder(5,5,5,5)),
      areaScrollPane.getBorder()));      
      Pane.add(areaScrollPane);
      cp.add(Pane);
   }

   /**
     *  actionPerformed beinhaltet nur eine if abfrage ob der 
     *  close Button gedrückt wird und schließt dementscprechen dann das Fenster.
     *
     */

   public void actionPerformed(ActionEvent event) {
     String cmd = event.getActionCommand();  
     
     if(cmd.equals("Close")) {
       System.out.println("Closing HelpWindow...\n");
       setVisible(false);
       dispose();           
     }        
   }
 }