/*
 *  inputChild.java  
 */ 
 
 import java.io.*;
 import java.util.*;
 import java.lang.*;   
 import java.lang.Object.*;
 
 import java.awt.*;
 import java.awt.event.*;
 import java.awt.FlowLayout.*;
 
 import javax.comm.*;
 import javax.comm.SerialPort.*;

 import javax.swing.*;
 import javax.swing.border.*;
 import javax.swing.JScrollPane.*;

 /**
   *  inputChild
   *  
   *  @version 2.0
   *  @author R.v.S - Team
   *
   *  inputChild ist die wichtigste Klasse des Auslese Programms denn 
   *  mit ihr wird die Verbindung zur seriellen Schnittstelle hergestellt
   *  und die Daten ausgelesen und in einem gewünschten File gespeichert.
   *
   */
   
 public class inputChild
 extends JInternalFrame
 implements ActionListener
 {
   private Container cp;
   public JTextArea  txtAusgabe;
   public JTextField txtEingabe;
   private static int comPort, timeout, baudrate, databits, 
     stopbits, parity, flowcontrol;
   private JButton bGo, bSave;
   private String filename;
   private FileWriter f;
   
   private InputThread it;
   private SerialPort com;
   private InputStream serIn;
   private OutputStream serOut;
   
   private boolean printMesg=false;
  
   /**
     *  inputChild setzt den Title des internen Frames und die Größe
     *  Sobald das geschehen ist beginnt es mit init die Komponenten zu 
     *  initialisierten und erstellen.
     *
     */
  
   public inputChild(String title)
   {
   	 super(title);
     int x=550, y=430;
     setSize(x,y);      
     init(x,y);
   } 
   
   /**
     *  init initalisiert und erstellt alle Komponenten wie Panels und 
     *  Buttons die benötigt werden.
     *
     */
  
   private void init(int x, int y) {  
     
     cp = getContentPane();    
     cp.setLayout(null);
     cp.setBounds(0,0,x,y);
   
     JPanel pane = new JPanel();
      pane.setLayout(null);
      pane.setBounds(0, 0, x+500, y+500);	
      pane.setBackground(new Color(87,171,78));   
   
     JPanel Pane = new JPanel();
      Pane.setBounds(20,20, 400, 320);
     BoxLayout pBox = new BoxLayout(Pane, BoxLayout.Y_AXIS);
     Pane.setLayout(pBox);
        
      txtAusgabe = new JTextArea();
      txtAusgabe.setFont(new Font("Courier New", Font.BOLD, 12));
      txtAusgabe.setTabSize(4);
      txtAusgabe.setEnabled(false);
     JScrollPane areaScrollPane = new JScrollPane(txtAusgabe);
      areaScrollPane.setVerticalScrollBarPolicy(
        JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
      areaScrollPane.setPreferredSize(new Dimension(250, 250));
      areaScrollPane.setBorder(
        BorderFactory.createCompoundBorder(
          BorderFactory.createCompoundBorder(
            BorderFactory.createTitledBorder("Received Messages"),
            BorderFactory.createEmptyBorder(5,5,5,5)),
      areaScrollPane.getBorder()));

      Pane.add(areaScrollPane);
      cp.add(Pane);
     
     JLabel lbl = new JLabel("Send Messages:");
      lbl.setBounds(20,340,100,20);
     pane.add(lbl);
     
      txtEingabe = new JTextField(30);	
      txtEingabe.setEnabled(true);
      txtEingabe.setBounds(20, 360, 400, 20);  
      txtEingabe.setFont(new Font("Courier New", Font.BOLD, 12));
      txtEingabe.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent event) {
          JTextField tf = (JTextField)event.getSource();  
     	  String msg = tf.getText();
 	 	  send(msg);
     	  tf.setText("");                  
        }
      });    
     pane.add(txtEingabe);    
         
	 JButton bClose = new JButton("Close");
	  bClose.setBounds(430, 50, 100, 40);
	  bClose.setBackground(Color.black);
	  bClose.setForeground(Color.white);	 
	  bClose.addActionListener(this);
	 pane.add(bClose);    
     
      bSave = new JButton("Save As");     
	  bSave.setBounds(430, 100, 100, 40);
	  bSave.setBackground(Color.black);
	  bSave.setForeground(Color.white);	 
	  bSave.addActionListener(this);
	 pane.add(bSave);    
         
	  bGo = new JButton("Go");     
	  bGo.setBounds(430, 150, 100, 40);
	  bGo.setBackground(Color.black);
	  bGo.setForeground(Color.green);	 
	  bGo.setEnabled(false);
	  bGo.addActionListener(this);
	 pane.add(bGo); 
	          
     JButton bClear = new JButton("Clear");     
	  bClear.setBounds(430, 200, 100, 40);
	  bClear.setBackground(Color.black);
	  bClear.setForeground(Color.white);	 
	  bClear.addActionListener(this);
	 pane.add(bClear); 
     
     JButton bSend = new JButton("Send");     
	  bSend.setBounds(430, 350, 100, 40);
	  bSend.setBackground(Color.black);
	  bSend.setForeground(Color.white);	 
	  bSend.addActionListener(this);
	 pane.add(bSend); 
     
     cp.add(pane);     
   }
   
   public String getText() {
     return txtAusgabe.getText();	
   }
   
   public void setText(String text) {
     txtAusgabe.setText(text); 	  
   }

  /**
    *  actionPerformed führt alle Aktionen aus die es von
    *  Buttons oder dergleichen erhält.
    *
    */
  
   public void actionPerformed(ActionEvent event)
   {
     String cmd = event.getActionCommand();  
     
     if(cmd.equals("Save As")) {
   	   saveAs();  	  
     }
     
     if(cmd.equals("Clear")) {
       setText("");
     }
     
     if(cmd.equals("Send")) {
      	String msg = txtEingabe.getText();
 	 	send(msg);
     	txtEingabe.setText(""); 
     }
     
     if(cmd.equals("Close")) {
       close();
     } 
     
     if(cmd.equals("Go")) {
       go();	
     }  
     if(cmd.equals("Stop")) {
       stop();	
     }
   }
   
   /**
     *  saveAs erzeugt einen neuen FileChooser mit dem es möglich 
     *  ist den Speicherort und den Filename zu spezifizieren.
     *  Wurde ein Filename und Speicherort ausgesucht wird der 
     *  go Button freigegeben. 
     *
     */
   
   private void saveAs() {
     JFileChooser chooser = new JFileChooser();
     int returnVal = chooser.showSaveDialog(this);
     if(returnVal == JFileChooser.APPROVE_OPTION) {
       File file = chooser.getSelectedFile();
       filename = file.getPath();  
       System.out.println("You choosed this filename and path: " + filename);
       bGo.setEnabled(true);
     }  	
   }
	
   /**
     *  go wird aufgerufen sobald der Go Button gedrückt wurde.
     *  go gibt den stop Button frei und öffnet das soeben
     *  mit saveAs ausgewählte File. Danach wird mittels des boolean go
     *  dem InputThread mitgeteilt das er nun die Daten ins File schreiben
     *  darf.
     *
     */
     
   private void go() {
     System.out.println("Go!!!");	
     bGo.setText("Stop");
	 bGo.setForeground(Color.red); 
	 bSave.setEnabled(false);
	      
     System.out.println("Saving Text to File...\n");
	 String text = getText();
	  
	   try {
      	 f = new FileWriter(filename);
      	 f.write("Filename : "+ filename +"\n");
      	 writeDate(f);      
      	 it.setFileWriter(f);
      	 it.setGo(true);      	 
       } catch (IOException e) {
         String message = "Fehler beim speichern der Datei:"+filename+"\n"+e.toString();
         System.out.println(message);
         JOptionPane.showMessageDialog(
           this,
       	   message,
       	   "File Saving Error", 
       	   JOptionPane.ERROR_MESSAGE);  
       }	
       System.out.println("saved...\n");
   }   
   
   /**
     *  die Funktion stop beendet den Schreibprozess auf das File
     *  und schließt es auch gleichzeitig.     
     *
     */
     
   private void stop() {
   	 bSave.setEnabled(true);
	 
     System.out.println("Stop!!!");	
       try {
	     it.setGo(false);
	     f.close();
	   } catch (IOException e) {
         String message = "Fehler beim speichern der Datei:"+filename+"\n"+e.toString();
         System.out.println(message);
         JOptionPane.showMessageDialog(
           this,
       	   message,
       	   "File Saving Error", 
       	   JOptionPane.ERROR_MESSAGE);  
       }
	   JOptionPane.showMessageDialog(
         this,
       	 "File saved!!\n"+filename,
       	 "File saved", 
       	 JOptionPane.ERROR_MESSAGE);  
       txtAusgabe.setText(""); 
     bGo.setText("Go");
	 bGo.setForeground(Color.green); 
   }
   
   /**
     *  mit send kann ein MessageString über die Serielle an das 
     *  angeschlossene Gerät gesendet werden.
     *
     */
   
   private void send(String msg) {
     txtAusgabe.append(msg+"\n");
     try {        	    
        serOut.write((msg+"\r\n").getBytes());
    	System.out.println("sending # "+msg);
     } catch(Exception e) { 
       System.err.println(e.toString());          
       JOptionPane.showMessageDialog(this, e.toString(),"Error in Sending", JOptionPane.ERROR_MESSAGE);  
     };     	
   }
   
   /**
     *  close wird aufgerufen sobald der close Button gedrückt wird 
     *  und soll nun alle Streams und das Fenster schliesen.
     *
     */
   
   public void close() {
     try{
       System.out.println("Closing Serial Link...\n");
       it.stopInput();  
       serOut.close();
       serIn.close();  
       com.close();       
       setVisible(false);
       dispose(); 
       System.out.println("Serial Link closed ...\n");
     } catch (Exception e) {
        System.err.println(e.toString());          
        JOptionPane.showMessageDialog(this, e.toString(),"Closing Error", JOptionPane.ERROR_MESSAGE);  
     }    			
   }
   
  /**
    *  mit setPortOptions werden die Optionen von der Hauptklasse an
    *  diese Klasse übermittelt.
    *
    */  

  public void setPortOptions(int comPort,int baudrate,int timeout, int databits, int stopbits, int parity, int flowcontrol) {
    this.comPort  = comPort;
	this.baudrate = baudrate;
	this.timeout  = timeout;		 
	this.databits = databits;
    this.stopbits = stopbits;
    this.parity   = parity;
    this.flowcontrol= flowcontrol;
  }
  
  /**
    *  init initialisiert die serielle Schnittstelle mit den
    *  gewünschten Optionen
    *
    */
  
  public void init() 
  throws Exception {       
    Enumeration en = CommPortIdentifier.getPortIdentifiers();
    while (en.hasMoreElements()) {
      CommPortIdentifier cpi = (CommPortIdentifier)en.nextElement();
      if (cpi.getPortType() == CommPortIdentifier.PORT_SERIAL) {
        if (cpi.getName().equals("COM"+comPort)) {                 	
          com = (SerialPort)cpi.open(
            "Com"+comPort, 
            timeout
          );
          
          System.out.println("set databits: "+databits+", stopbits: "+stopbits+", parity: "+parity);
          com.setSerialPortParams(baudrate,databits,stopbits,parity);
          
          System.out.println("set flowcontrol: "+flowcontrol);
          com.setFlowControlMode(SerialPort.FLOWCONTROL_NONE);
           
          System.out.println("Serial Link up ...");                     
          serOut = com.getOutputStream();            
          serIn  = com.getInputStream();            
          System.out.println("Reader created...");
          it = new InputThread(serIn, txtAusgabe);
          it.start();              
        }
      }
    }	
  }
  
  /**
    *  liefert den OutputStream der seriellen Schnittstelle zurück
    *
    */ 
  
  public OutputStream getOutputStreamWriter() {
    return serOut;
  }
  
  /**
    *  liefert den InputStream der seriellen Schnittstelle zurück
    *
    */ 
  
  public InputStream getInputStreamReader() {
    return serIn;	
  }
 
  /**
    *  mit sleep können Verzögerungen im Programm 
    *  gemacht werden.
    *
    */
 
  public void sleep(int sleepTime) {
    try {
      Thread.sleep(sleepTime);
    } catch	(Exception e){ }
  }

  /**
    *  writeDate schreibt das aktuelle Datum in die 
    *  der Funktion übergebenen Datei.
    *
    */
  
  public void writeDate(FileWriter fw)
  throws IOException {
    GregorianCalendar cal = new GregorianCalendar();   
    fw.write(getTime(cal)+"\r\n"+getDate(cal)+"\r\n"+getWeek(cal)+"\r\n");
    System.out.println("Date written ... ");
  }
  
  /**
    *  getDate liefert das aktuelle Datum von der, 
    *  der Funktion übergebenen Kalenderobjekt als 
    *  String zurück.
    *
    */ 
    
   private String getDate(GregorianCalendar cal) {
     String Date = (
       "Date : " +
       cal.get(Calendar.DATE) + "." +
       (cal.get(Calendar.MONTH)+1) + "." +
       cal.get(Calendar.YEAR)
     );   
     return Date;
   }
   
  /**
    *  getTime liefert die aktuelle Zeit von der, 
    *  der Funktion übergebenen Kalenderobjekt als 
    *  String zurück.
    *
    */ 
    
   private String getTime(GregorianCalendar cal) {
     String Time = (
       "Time : " +
       cal.get(Calendar.HOUR_OF_DAY) + ":" +
       cal.get(Calendar.MINUTE) + ":" +
       cal.get(Calendar.SECOND) + " (+" +
       cal.get(Calendar.MILLISECOND) + " ms)"
     );   
     return Time;
   }
      
  /**
    *  getWeek liefert die aktuelle Kalendarwoche von der ,
    *  der Funktion übergebenen Kalenderobjekt als 
    *  String zurück.
    *
    */ 
   
   private String getWeek(GregorianCalendar cal) {
     String KW = (
       "KW   : " +
       cal.get(Calendar.WEEK_OF_YEAR)
     );   
     return KW;
   }
}

/**
  *  class InputThread 
  *
  *  Die Klasser InputThread wird dafür verwendet um von einem 
  *  gegebenen InputStream die Daten einzulesen und in ein File 
  *  zu schreiben.
  *
  */
  
class InputThread 
extends Thread 
{
  private InputStream serIn;
  private JTextArea txt;
  private boolean inputRun=true;
  private FileWriter f;
  private boolean go=false;
  
  /**
    *  übergeben des Streams.
    */
  
  public InputThread(InputStream serIn, JTextArea txt) {
  	this.serIn = serIn; 
  	this.txt = txt;
  }	
  
  /**
    *  startet den Thred und beginnt mit dem auslesen des Files.
    *
    */
  
  public void run() { 
    System.out.println("Input Thread started ...");
    StringBuffer s; int c;      
    while (inputRun) {
   	  try {    
        s = new StringBuffer();
   	    String line="";
   	    while ((c = serIn.read()) != '\n' ) {
          s.append((char)c);        
        }          
        line = s.toString();
      
        System.out.println("received # "+line);  
        if(go) {
          f.write(line+"\n");        	
        }
        txt.append(line+"\n");     	
      	
      }   catch(Exception e) {      	
        System.err.println("Error in serial inputting!!! \n"+e.toString());
        System.exit(1);        
      } 
    }
    System.out.println("Input Thread closed ...");    
  } 
  
  /**
    *  mit setGo kann der boolean go gesetzt werden durch 
    *  welchen es gewährleistet ist das die Daten in das 
    *  File geschrieben werden.
    *
    */   
   
  public void setGo(boolean state) {
    go = state;	
  }
  
  /**
    *  setFileWriter übergibt den nötigen FileWriter der 
    *  benötigt wird um die Daten in das file zu schreiben.
    *
    */
  
  public void setFileWriter(FileWriter f) {
    this.f = f;	
  }
  
  /**
    *  stopInput beendet den Thread 
    * 
    */
   
  public void stopInput() {
    inputRun = false;
  }
}