/* 
 *  openChild.java
 */
  
 import java.io.*;
 import java.util.*;
 
 import java.lang.*;   
 import java.lang.Object.*;
 
 import java.awt.*;
 import java.awt.event.*;
 import java.lang.Object.*;
 import java.awt.FlowLayout.*;
 
 import javax.comm.*; 
 import javax.swing.*;
 import javax.swing.border.*;
 import javax.swing.JScrollPane.*;
   
 /**
   *  openChild
   *
   *  @version 2.0
   *  @author R.v.S - Team
   *
   *  Mittels openChild können TextFiles angesehen werden.
   *
   */  
   
 public class openChild
 extends JInternalFrame
 implements ActionListener
 {
   private Container cp;
   private String filename;
   private JTextArea textArea;
   private FileReader f;
    
   /**
     *  Der Konstruktor sorgt dafür das init aufgerufen wird und
     *  der Titel und die Größe gesetzt werden.
     */   
   
   public openChild(String title, String filename) {
	 super(title);	 
	 this.filename=filename;
     int x=500, y=400;
     setIconifiable(false);
     setMaximizable(false);
     setResizable(false);      
     setSize(x+10, y+100); 
     setDefaultCloseOperation(JInternalFrame.DISPOSE_ON_CLOSE);     
     cp = getContentPane(); 
     init(x,y);
     openFile();
   } 
   
   /**
     *  openFile öffnet das gewünschte File und stellt es 
     *  in der TextArea dar.
     *     
     */
   
   private void openFile() {
     int c;
     StringBuffer s = new StringBuffer();
   	 String line="";
     
     try {
       f = new FileReader(filename);
       while ((c = f.read()) != -1) {
       	 s.append((char)c);         
       }
       f.close();
     } catch (IOException e) {
       String message ="Fehler beim öffnen der Datei:"+filename+"\n"+e.toString();
       System.out.println(message);
       JOptionPane.showMessageDialog(
       		this,
       		message,
       		"File Open Error", 
       		JOptionPane.ERROR_MESSAGE);  
     }
     textArea.setText("");
     textArea.append(s.toString());	
   }
   
   /**
     *  init initialisiert und erstellt alle Komponenten die 
     *  auf den Frame dargestellt werden sollen.
     *
     */
   
   private void init(int x, int y) {     
     cp.setLayout(null);
     cp.setBounds(0,0,x,y);
   
     JPanel Pane = new JPanel();
     Pane.setBounds(20,20,460,360);
     BoxLayout pBox = new BoxLayout(Pane, BoxLayout.Y_AXIS);
     Pane.setLayout(pBox);
     
      textArea = new JTextArea();
      textArea.setFont(new Font("Courier New", Font.BOLD, 12));

     JScrollPane areaScrollPane = new JScrollPane(textArea);
      areaScrollPane.setVerticalScrollBarPolicy(
        JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
      areaScrollPane.setPreferredSize(new Dimension(250, 250));
      areaScrollPane.setBorder(
        BorderFactory.createCompoundBorder(
          BorderFactory.createCompoundBorder(
            BorderFactory.createTitledBorder("Info Text"),
            BorderFactory.createEmptyBorder(5,5,5,5)),
      areaScrollPane.getBorder()));      
     Pane.add(areaScrollPane);
     
     JButton bAct = new JButton("Actualize");     
	  bAct.setBounds(100, 400, 100, 40);
	  bAct.setBackground(Color.black);
	  bAct.setForeground(Color.white);	 
	  bAct.addActionListener(this);
	 cp.add(bAct);
	 
	 JButton bClose = new JButton("Close File");     
	  bClose.setBounds(220, 400, 100, 40);
	  bClose.setBackground(Color.black);
	  bClose.setForeground(Color.white);	 
	  bClose.addActionListener(this);
	 cp.add(bClose);    
     cp.add(Pane);
   }

   /**
     *  actionPerformed beinhaltet hier ob der 
     *  close Button gedrückt wird und schließt dementscprechen dann das Fenster.
     *  oder ob der actualize Button gedrückt wurde und aktualisiert dann die Anzeige.
     *
     */

   public void actionPerformed(ActionEvent event)
   {
     String cmd = event.getActionCommand();  
     
     if(cmd.equals("Close File")) {
       System.out.println("Closing file :" +filename);
       setVisible(false);
       dispose();           
     }        
     
     if(cmd.equals("Actualize")) {
       String message="File had been actualized !";
       System.out.println(message);
       JOptionPane.showMessageDialog(
         this,
       	 message,
         "File Operation", 
       	 JOptionPane.INFORMATION_MESSAGE);  
       openFile();
     }     
   }
 }