/*
 *  optionsChild.java  
 */

import java.lang.*;
import java.lang.Math.*;
import java.lang.String.*;

import java.awt.*;
import java.awt.event.*;

import javax.comm.*;
import javax.comm.SerialPort.*;

import javax.swing.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

/**
  *  optionChild
  *
  *  @version 2.0
  *  @author R.v.S - Team
  *  
  *  optionchild wird benötigt um die Optionen für die
  *  serielle Schnittstelle einzustellen.
  *
  *  die standard Com Port Options sind:
  *  	o Baudrate     : 9600 Baud
  *  	o Port         : Com 2
  *  	o Parity	   : None
  *  	o Flow Control : None
  *  	o Databits     : 8
  *  	o Stopbits     : 1
  *
  */
public class optionChild
extends JInternalFrame
implements ActionListener
{
  private ButtonGroup group = new ButtonGroup();
  private JComboBox combo, cParity, cFlowControl, cDatabits, cStopbits;
  private JRadioButton rb;
  private JTextField toField;
  private int Comport, Baudrate, Timeout, Parity, Databits, Stopbits, FlowControl; 
  
  private rvsComSaveToFile rct; 
  private JButton set;
  private static Color yellow = new Color(251,218,140);
  
  private JRootPane rp;
  
  /**
    *  Der Konstruktor sorgt dafür das init aufgerufen wird und
    *  der Titel und die Größe gesetzt werden.
    *
    */   
   
  public optionChild(rvsComSaveToFile rcstf)
  {
    super("Serial Port Options");
    rct = rcstf;
    Container cp = getContentPane();
    rp = getRootPane();
    cp.setLayout(null);
    setBackground(yellow);
    setLocation(0,0);
    setSize(430,300);    
    OptionFrame  (  10,  10, 400, 250, cp );   
  }
   
  public static final String[] _flowcontrol = {
    "None"  ,"RTS/CTS IN"   ,"RTS/CTS OUT"  ,"XON/XOFF IN"  ,"XON/XOFF OFF"
  };  
  
  public static final String[] _stopbits = {
    " 1"  ," 2" ," 1,5"  
  };  
  
  public static final String[] _databits = {
    " 5"  ," 6"   ," 7"  ,"8"
  };  
  
  public static final String[] _parity = {
    "None"  ,"Odd"   ,"Even"  ,"Mark"  ,"Space"
  };  
     
  public static final String[] _baudrate = {
    " 110"  ," 300"   ," 1200"  ," 2400"  ," 4800"  ,
    " 9600" ," 19200" ," 38400" ," 57600" ," 115200" 
  };  
  
  /**
    *  OptionFrame initialisiert und erstellt alle Komponenten die 
    *  auf den Frame dargestellt werden sollen.
    *
    */
  
  public void OptionFrame(int x, int y, int w, int h, Container cp) {
  	  
    JPanel pane = new JPanel();
     pane.setBackground(yellow);
     pane.setBounds(x,y,w,h);
     pane.setLayout(null);
     pane.setBorder(BorderFactory.createTitledBorder("Options") );
    
    JLabel comlbl = new JLabel("Comport:");
     comlbl.setBounds(20,30,120,20);
    pane.add(comlbl);   
     	  
    JPanel panel = new JPanel();
     panel.setBackground(yellow);
     panel.setForeground(yellow);
     panel.setBounds(20,50,100,40);
     panel.setLayout(new GridLayout(2, 1));
     for (int i = 1; i <= 2; ++i) {
       rb = new JRadioButton("COM " + i, i == 2);
       rb.setActionCommand(rb.getText());
       panel.add(rb);
       group.add(rb);
     }
    pane.add(panel);    
   
    /* Baudrate*/
   
    JLabel baudlbl = new JLabel("Baudrate:");
     baudlbl.setBackground(yellow);
     baudlbl.setBounds(20,100,120,20);
    pane.add(baudlbl);
   
     combo = new JComboBox(_baudrate);
     combo.setSelectedIndex(5);
     combo.setEditable(true);
     combo.setBounds(20,120,100,20);
    pane.add(combo);       
   
    JLabel tolbl = new JLabel("Timeout:");
     tolbl.setBounds(20,150,120,20);
    pane.add(tolbl);
   
     toField = new JTextField(4);
     toField.setBounds(20,170,120,20);
     toField.setText("200");
    pane.add(toField);
   
     set = new JButton("OK");
     set.setBackground(Color.black);
     set.setForeground(Color.white);
     set.setBounds(20,200,140,30);
     set.addActionListener(this);
     set.setMnemonic(KeyEvent.VK_ENTER);
	pane.add(set);

    /* Flow Control */
    
    JLabel lbl1 = new JLabel("Flow Control:");
     lbl1.setBackground(yellow);
     lbl1.setBounds(200,20,120,20);
    pane.add(lbl1);
   
     cFlowControl = new JComboBox(_flowcontrol);
     cFlowControl.setSelectedIndex(0);
     cFlowControl.setEditable(true);
     cFlowControl.setBounds(200,40,120,20);
    pane.add(cFlowControl);       
  
    /* Databits */
     
    JLabel lbl2 = new JLabel("Databits:");
     lbl2.setBackground(yellow);
     lbl2.setBounds(200,70,120,20);
    pane.add(lbl2);
   
     cDatabits = new JComboBox(_databits);
     cDatabits.setSelectedIndex(3);
     cDatabits.setEditable(true);
     cDatabits.setBounds(200,90,120,20);
    pane.add(cDatabits);       
      
    /* Stopbits */
      
    JLabel lbl3 = new JLabel("Stopbits:");
     lbl3.setBackground(yellow);
     lbl3.setBounds(200,120,120,20);
    pane.add(lbl3);
   
     cStopbits = new JComboBox(_stopbits);
     cStopbits.setSelectedIndex(0);
     cStopbits.setEditable(true);
     cStopbits.setBounds(200,140,120,20);
    pane.add(cStopbits);
        
    /* Parity */	
	
    JLabel lbl4 = new JLabel("Parity:");
     lbl4.setBackground(yellow);
     lbl4.setBounds(200,170,120,20);
    pane.add(lbl4);
   
     cParity = new JComboBox(_parity);
     cParity.setSelectedIndex(0);
     cParity.setEditable(true);
     cParity.setBounds(200,190,120,20);
    pane.add(cParity);
        	
	cp.add(pane);
  }  
  
  /**
    *  readDate liest alle ausgewählten Daten aus den 
    *  Komponenten aus und speichert diese.
    * 
    */  
  
  private void readData() {
    String p="";
    ButtonModel selected = group.getSelection();
    if (selected != null) {
      p = selected.getActionCommand();
    }    
    String port = p.substring(p.length()-1,p.length());
    Comport = Integer.parseInt(port);
    /*Baudrate*/
     int b = combo.getSelectedIndex();
     Baudrate = Integer.parseInt(_baudrate[b].trim());
    
    /*FlowControl*/
     double e = cFlowControl.getSelectedIndex();
     if(e==0) e =(double)0;
     else e = (Math.pow((double)2,(double)e))/(double)2;     
     FlowControl = (int)e;// Integer.parseInt(_flowcontrol[b].trim());
   
    /*Databits*/
     b = cDatabits.getSelectedIndex();
     Databits =b+5;// Integer.parseInt(_databits[b].trim());
   
    /*Stopbits*/
     b = cStopbits.getSelectedIndex();
     Stopbits =b+1;// Integer.parseInt(_stopbits[b].trim());
   
    /*Paritybits*/
     b = cParity.getSelectedIndex();
     Parity =b;// Integer.parseInt(_parity[b].trim());
    
    /*timeout*/
     Timeout = Integer.parseInt(toField.getText());
  }
  
  /**
    *  liefert die Baudrate der seriellen Schnittstelle als 
    *  Integer zurück    
    */
  
  public int getBaudrate() {
    return Baudrate;	
  }
  
  /**
    *  liefert den Port der seriellen Schnittstelle als 
    *  Integer zurück    
    */
    
  public int getComPort() {
    return Comport;	
  }
  
  /**
    *  liefert das TimeOut der seriellen Schnittstelle als 
    *  Integer zurück    
    */
    
  public int getTimeOut() {
    return Timeout;	
  }
    
  /**
    *  liefert die Anzahl der Datenbits der seriellen Schnittstelle als 
    *  Integer zurück    
    */
    
  public int getDatabits() {
    return Databits;	
  }
    
  /**
    *  liefert die Anzahl der Stopbits der serielle Schnittstelle als 
    *  Integer zurück    
    */
    
  public int getStopbits() {
    return Stopbits;	
  }
  
  /**
    *  liefert die Parität der seriellen Schnittstelle als 
    *  Integer zurück    
    */
    
  public int getParity() {
    return Parity;	
  }
    
  /**
    *  liefert den Flusskontrolltyp der seriellen Schnittstelle als 
    *  Integer zurück    
    */
    
  public int getFlowControl() {
    return FlowControl;	
  }
    
  /**
    *  wartet darauf das die Ok Taste gedrückt wird
    *  und führt dann die ok Funktion aus  
    */
    
  public void actionPerformed(ActionEvent event) {
    String cmd = event.getActionCommand();   
    if (cmd.equals("OK")) {
   		ok();
    }    
  }       
    
  /**
    *  ok wird ausgeführt sobald der OK Button gedrückt wurde und 
    *  fordert readDate dazu auf die Daten der komponenten einzulesen.
    *   
    */
  
  private void  ok() {
    readData();
    rct.optionItem.setEnabled(true);
    rct.newItem.setEnabled(true);
    this.setVisible(false);   	 
    this.dispose();

    System.out.println("\n Comport     :" + getComPort()     +
  	    			   "\n Baudrate    :" + getBaudrate()    +
  	    			   "\n Parity      :" + getParity()      +
  	    			   "\n FlowControl :" + getFlowControl() +
  	    			   "\n Databits    :" + getDatabits()    +
  	    			   "\n Stopbits    :" + getStopbits()    +  	    			   
  	  				   "\n Timeout     :" + getTimeOut());
  }


  public void keyTyped    ( KeyEvent event) {  }
  public void keyPressed  ( KeyEvent event) { keyFunction(event); }
  public void keyReleased ( KeyEvent event) {  }
   
  /**
    *  ausführen eines spezifizierten Key Events
    *
    */
    
  public void keyFunction ( KeyEvent e) {
  
   	int keyCode = e.getKeyCode(); 
   	System.out.println("pressed:" + keyCode);
   	
    switch (keyCode) {
   	    				
      case (int)KeyEvent.VK_ENTER :
		ok();
      break;   
    }
  }
}