/*		
 *  rvsComSaveToFile.java
 */
  
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.JFrame.*;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.filechooser.*;
import javax.swing.JInternalFrame.*;
import javax.swing.JDesktopPane.*;

/**
  *  rvsComSaveToFile
  *
  *  @version 2.0
  *  @author R.V.S-Team
  * 
  *  Die Klasse rvsComSaveToFile ist die Hauptklasse der Projekts
  *  R.v.S Routenstatistik von Segelregatten und dient
  *  zum auslesen, und speichern der Daten einer R.v.S mobile Unit.  
  *
  */
  
public class rvsComSaveToFile
extends JFrame 
implements ActionListener {
	
	static private final String newline = "\n";
    private JFileChooser fc;
    private JTextArea log;
    private boolean optionFlag = false;
    private optionChild ser;
    private int comPort, baudrate, timeout, Parity, Databits, Stopbits, FlowControl;
    
	public JMenuItem newItem,optionItem;
    JDesktopPane desktop;
   
    /**
      *  Der Konstruktor von rvsComSaveToFile
      *  wird gleich nach Programmstart aufgerufen und initialisiert alle
      *  Menüelemente und Unterklassen.
      *
      */ 
   
    public rvsComSaveToFile() {
      super(". . . : : : R.v.S - Routenstatistik von Segelregatten : : : . . .");
      //Closing things
      addWindowListener(
      	new WindowAdapter() {
          public void windowClosing(WindowEvent e) {
            System.exit(0);
          }
        }
      );        
      Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	  Dimension size = getSize();
	  int y = screenSize.height;
	  int x = screenSize.width-200;
	  setSize(x, y);	        
               
      //desktop  
      desktop = new JDesktopPane(); 
      setContentPane(desktop);
      
      //Menubar  
      JMenuBar jmb = new JMenuBar();
      jmb.add(createFileMenu()); 
      jmb.add(createOptionsMenu());
      jmb.add(createHelpMenu());
      jmb.add(createVisuMenu());
      setJMenuBar(jmb);

  	  JPanel upane = new JPanel();
      upane.setLayout(null);
      upane.setBounds(0,0,x,80);
      upane.setBackground(new Color(219,7,37));
 	
      //Ueberschrift
 	  String text = " Routenstatistik von Segelregatten ";  
 	  String version = "v2.0";	
  	  JLabel lblUber = new JLabel(text);
  	  lblUber.setFont(new Font("Arial Black",Font.PLAIN,36));
  	  lblUber.setForeground(Color.black); 
  	  lblUber.setBounds(250,10,1000,55);
  	  upane.add(lblUber);
  	
  	  JLabel lblVersion = new JLabel(version);    
      lblVersion.setFont(new Font("Courier New",Font.PLAIN,12));
      lblVersion.setBounds(x-40,10,100,20);
      upane.add(lblVersion);  	
  	  desktop.add(upane); 

	  //Backgroundimage        
      ImageIcon hIcon = new ImageIcon("images/boat.gif");
	  JLabel lbl = new JLabel(hIcon);
	  lbl.setBounds(x/2-240,y/2-240,480,480);
	  desktop.add(lbl);
	  desktop.setBackground(Color.black);
	  desktop.setLayout(null);
		
	  //Make dragging faster:
      desktop.putClientProperty("JDesktopPane.dragMode", "outline");
    }

	/**
	  *  createFileMenu erzeugt ein Filemenu 
	  *  in welchem sich die Optionen New, Open File und Exit befinden
	  *    o New: wird verwendet um eine Serielle Verbindung herzustellen
	  *      sobald die Optionen für diese eingestellt worden sind
	  *    o Open File: dient zum späteren ansehen der eingelesenen Daten.
	  *    o Exit: mit Exit kann das Programm beendet werden.
	  *
	  */
		
    private JMenu createFileMenu() {
    	
    	ImageIcon openIcon = new ImageIcon("images/open.gif");
		ImageIcon saveIcon = new ImageIcon("images/save.gif");
		ImageIcon newIcon  = new ImageIcon("images/new.gif");
		ImageIcon stopIcon = new ImageIcon("images/stop.gif");
		 
	    JMenu file = new JMenu ("File");	    
	    file.setMnemonic(KeyEvent.VK_F);
    	JMenuItem item; 
    	   
    	file.add (newItem = new JMenuItem ("New",newIcon));
    	newItem.setMnemonic(KeyEvent.VK_N);
    	newItem.addActionListener (this);    	
    	newItem.setEnabled(false);
    	
    	file.add (item = new JMenuItem ("Open File",openIcon));
    	item.addActionListener (this);
    	item.setMnemonic(KeyEvent.VK_O);
  
     	file.addSeparator();
    	file.add (item = new JMenuItem ("Exit",stopIcon));
    	item.addActionListener (this);
    	item.setMnemonic(KeyEvent.VK_E);
    	
    	return file;
    }
    
    /**
      *  createOptionsMenu wird dazu verwendet ein Menue für die 
      *  Einstellungen zu erstellen. Diese werden verwendet um die 
      *  für die serielle Schnittstelle wichtigen Parameter einzustellen.
      *
      */
    
    private JMenu createOptionsMenu() {      
     	ImageIcon prefIcon  = new ImageIcon("images/pref.gif");     		
	    JMenu options = new JMenu ("Options");
	    options.setMnemonic(KeyEvent.VK_O);
    	JMenuItem item;
    	options.add (optionItem = new JMenuItem ("Options", prefIcon));
		optionItem.addActionListener (this);
		optionItem.setMnemonic(KeyEvent.VK_O);
								
		return options;
    }  
    
    /**
      *  Mittels createHelpMenu wird das Hilfemenue erzeugt über 
      *  welches man entweder die ReadMe datei oder das InfoPane
      *  sich anzeigen lassen kann.
      *
      */
    
    private JMenu createHelpMenu() {      
        	
        ImageIcon infoIcon = new ImageIcon("images/info.gif");
		ImageIcon tipIcon  = new ImageIcon("images/tip.gif");
		
	    JMenu help = new JMenu ("Help");
    	JMenuItem item;
		help.add (item = new JMenuItem ("Help",tipIcon));
		item.addActionListener (this);
		help.add (item = new JMenuItem ("Info",infoIcon));
		item.addActionListener (this);
				
		return help;
    } 
    
    /**
      *  Dieses Menü erzeugt Menüeinträge damit man die Datenumrechnung
      *  und Visualisierung starten kann.
      *
      */    
    	
    private JMenu createVisuMenu() {
    	    	 
	    JMenu visu = new JMenu ("Visualisierung");	    	    
    	JMenuItem item; 
    	   
    	visu.add (item = new JMenuItem ("Umrechnung") );    	
    	item.addActionListener (this);    	    	
    	
    	visu.add (item = new JMenuItem ("Visualisierung") );
    	item.addActionListener (this);
     	
  		item = null;
  		
    	return visu;
    }
     
 	/**
 	  *  actionPerformed führt alle Aktionen der Buttons aus
 	  *
 	  */ 	
 	  
    public void actionPerformed(ActionEvent event)
    {
      String cmd = event.getActionCommand();
          
      if(cmd.equals("New")) {
      	newConnection();
      }    
    
      if(cmd.equals("Open File")) {    
        openFile();
      }
            
      if(cmd.equals("Options")) {    
        options();       
      }
      
      if(cmd.equals("Help")) {  
        helpChild help = new helpChild("Help Window","ReadMe.txt");    
        help.setVisible(true); 	
        desktop.add(help);
        try {
            help.setSelected(true);
        } catch (java.beans.PropertyVetoException e) {}   
      }  
      
      if(cmd.equals("Info")) {  
        JOptionPane.showMessageDialog(
          this,
          "programmed by R.v.S Team\n(C)opyright 2001",
          "INFO", 
          JOptionPane.INFORMATION_MESSAGE);
      }
      
      if(cmd.equals("Exit")) { 
        this.setVisible(false);
        this.dispose();      
        System.exit(0);
      }
    }
    
    /**
      *  mit newConnection wird versucht eine Verbindung mit der Seriellen 
      *  Schnittstelle aufzubauen. hierfür wird ein neuer InputChild erzeugt und
      *  zum JFrame hinzugefügt. Ist die Schnittstelle schon in Gebrauch wird 
      *  eine Fehlermeldung ausgegeben.
      *
      */
    
    private void newConnection() {         	
      comPort = ser.getComPort();
      baudrate = ser.getBaudrate();
      timeout = ser.getTimeOut();   
      Parity = ser.getParity();
      FlowControl = ser.getFlowControl(); 
      Databits = ser.getDatabits();
      Stopbits = ser.getStopbits();
      Parity = ser.getParity();
      inputChild frame;                	
      try{ 
        frame = new inputChild("@Serial Port: "+comPort+", @baudrate: "+baudrate);    
        frame.setPortOptions(comPort,baudrate,timeout,Databits,Stopbits,Parity,FlowControl);
        frame.init(); 
        frame.setVisible(true); 	
        desktop.add(frame);
        try {
          frame.setSelected(true);
        } catch (java.beans.PropertyVetoException e) { }           
      } catch (Exception e) {
        String message=e.toString();
        System.err.println(message);          
        JOptionPane.showMessageDialog(this,"Error: "+message,"Serial Port Error", JOptionPane.ERROR_MESSAGE);  
        frame=null;
      }        	
    }
    
    /**
      *  openFile erzeugt einen neuen FileChooser mit dem 
      *  der Speicherort und Dateiname ausgesucht werden.
      *  Sobald das geschehen ist wird ein neues OpenChild erstellt
      *  und dem Frame hinzugefügt. Sollte kein file ausgesucht werden
      *  wird die Aktion abgebrochen.
      *
      */	
    
    private void openFile() {
      JFileChooser chooser = new JFileChooser();
      int returnVal = chooser.showOpenDialog(this);
      String filename;
      if(returnVal == JFileChooser.APPROVE_OPTION) {
        filename = chooser.getSelectedFile().getPath();
        System.out.println("You choosed to open file: " +filename);
	    openChild frame = new openChild("Opened File:",filename);
		frame.setVisible(true); 
        desktop.add(frame);
        try {
          frame.setSelected(true);
	    } catch (java.beans.PropertyVetoException e) {}
	  } else {
	    String message="Open command cancelled by user";
	    JOptionPane.showMessageDialog(this,"Error: "+message,"Open Error", JOptionPane.ERROR_MESSAGE);         	
	  }        	    	
    }
    
	/**
	  *  mit Hile der options Funktion wird ein neues
	  *  OptionChild erstellt und zum Frame hinzugefügt.
	  *
	  */	
	
	private void options() {
	  optionItem.setEnabled(false);
      ser=null;
      ser = new optionChild(this);            
      ser.setVisible(true); 	
      desktop.add(ser);
      try {
        ser.setSelected(true);
      } catch (java.beans.PropertyVetoException e) {}    	
	}
	
	
    /**
	  *  main funktion dient zur Ausführung des Programms
	  *  sobald der Konstruktor alle Initialisierungsaufrufe
	  *  beendet hat wird der Frame sichtbar gestzt.
	  *  @param Kommandozeilenparameter sind nicht notwendig für die Ausführung
	  *
	  */
	  
    public static void main(String[] args) {
      System.setErr( System.out);
      rvsComSaveToFile frame = new rvsComSaveToFile();
      frame.setVisible(true);
    }
}